diff --git a/gnome-session/gsm-session-fill.c b/gnome-session/gsm-session-fill.c
index b94dec25..d6aeaa50 100644
--- a/gnome-session/gsm-session-fill.c
+++ b/gnome-session/gsm-session-fill.c
@@ -23,36 +23,117 @@
 
 #include "gsm-system.h"
 #include "gsm-manager.h"
+#include "gsm-process-helper.h"
+#include "gsm-util.h"
 
 #define GSM_KEYFILE_SESSION_GROUP "GNOME Session"
+#define GSM_KEYFILE_RUNNABLE_KEY "IsRunnableHelper"
+#define GSM_KEYFILE_FALLBACK_KEY "FallbackSession"
+#define GSM_KEYFILE_REQUIRED_COMPONENTS_KEY "RequiredComponents"
+
+/* See https://bugzilla.gnome.org/show_bug.cgi?id=641992 for discussion */
+#define GSM_RUNNABLE_HELPER_TIMEOUT 3000 /* ms */
+
+typedef void (*GsmFillHandleComponent) (const char *component,
+                                        const char *app_path,
+                                        gpointer    user_data);
 
 static void
-load_standard_apps (GsmManager *manager,
-                    GKeyFile   *keyfile)
+handle_required_components (GKeyFile               *keyfile,
+                            GsmFillHandleComponent  callback,
+                            gpointer                user_data)
 {
-        char *dir;
-        const char * const *system_dirs;
+        char **required_components;
         int    i;
 
-        if (g_key_file_get_boolean (keyfile, GSM_KEYFILE_SESSION_GROUP, "Kiosk", NULL))
+        g_assert (keyfile != NULL);
+        g_assert (callback != NULL);
+
+        required_components = g_key_file_get_string_list (keyfile,
+                                                          GSM_KEYFILE_SESSION_GROUP,
+                                                          GSM_KEYFILE_REQUIRED_COMPONENTS_KEY,
+                                                          NULL, NULL);
+
+        if (!required_components)
                 return;
 
-        dir = g_build_filename (g_get_user_config_dir (), "autostart", NULL);
-        gsm_manager_add_autostart_apps_from_dir (manager, dir);
-        g_free (dir);
+        for (i = 0; required_components[i] != NULL; i++) {
+                char *app_path;
 
-        system_dirs = g_get_system_data_dirs ();
-        for (i = 0; system_dirs[i]; i++) {
-                dir = g_build_filename (system_dirs[i], "gnome", "autostart", NULL);
-                gsm_manager_add_autostart_apps_from_dir (manager, dir);
-                g_free (dir);
+                app_path = gsm_util_find_desktop_file_for_app_name (required_components[i],
+                                                                    TRUE);
+                callback (required_components[i], app_path, user_data);
+                g_free (app_path);
         }
 
-        system_dirs = g_get_system_config_dirs ();
-        for (i = 0; system_dirs[i]; i++) {
-                dir = g_build_filename (system_dirs[i], "autostart", NULL);
-                gsm_manager_add_autostart_apps_from_dir (manager, dir);
-                g_free (dir);
+        g_strfreev (required_components);
+}
+
+static void
+check_required_components_helper (const char *component,
+                                  const char *app_path,
+                                  gpointer    user_data)
+{
+        gboolean *error = user_data;
+
+        if (app_path == NULL) {
+                g_warning ("Unable to find required component '%s'", component);
+                *error = TRUE;
+        }
+}
+
+static gboolean
+check_required (GKeyFile *keyfile)
+{
+        gboolean error = FALSE;
+
+        g_debug ("fill: *** Checking required components");
+
+        handle_required_components (keyfile,
+                                    check_required_components_helper,
+                                    &error);
+
+        g_debug ("fill: *** Done checking required components");
+
+        return !error;
+}
+
+static void
+append_required_components_helper (const char *component,
+                                   const char *app_path,
+                                   gpointer    user_data)
+{
+        GsmManager *manager = user_data;
+
+        if (app_path == NULL)
+                g_warning ("Unable to find required component '%s'", component);
+        else
+                gsm_manager_add_required_app (manager, app_path);
+}
+
+
+static void
+load_standard_apps (GsmManager *manager,
+                    GKeyFile   *keyfile)
+{
+        g_debug ("fill: *** Adding required components");
+        handle_required_components (keyfile,
+                                    append_required_components_helper,
+                                    manager);
+        g_debug ("fill: *** Done adding required components");
+
+        if (!gsm_manager_get_failsafe (manager)) {
+                char **autostart_dirs;
+                int    i;
+
+                autostart_dirs = gsm_util_get_autostart_dirs ();
+
+                for (i = 0; autostart_dirs[i]; i++) {
+                        gsm_manager_add_autostart_apps_from_dir (manager,
+                                                                 autostart_dirs[i]);
+                }
+
+                g_strfreev (autostart_dirs);
         }
 }
 
@@ -60,6 +141,8 @@ static GKeyFile *
 get_session_keyfile_if_valid (const char *path)
 {
         GKeyFile  *keyfile;
+        gsize      len;
+        char     **list;
 
         g_debug ("fill: *** Looking if %s is a valid session file", path);
 
@@ -75,6 +158,15 @@ get_session_keyfile_if_valid (const char *path)
                 goto error;
         }
 
+        list = g_key_file_get_string_list (keyfile,
+                                           GSM_KEYFILE_SESSION_GROUP,
+                                           GSM_KEYFILE_REQUIRED_COMPONENTS_KEY,
+                                           &len, NULL);
+        if (list)
+                g_strfreev (list);
+        if (len == 0)
+                g_warning ("Session '%s': no component in the session.", path);
+
         return keyfile;
 
 error:
@@ -131,11 +223,68 @@ find_valid_session_keyfile (const char *session)
 }
 
 static GKeyFile *
-get_session_keyfile (const char *session)
+get_session_keyfile (const char *session,
+                     char      **actual_session,
+                     gboolean   *is_fallback)
 {
         GKeyFile *keyfile;
+        gboolean  session_runnable;
+        char     *value;
+        GError *error = NULL;
+
+        *actual_session = NULL;
+
         g_debug ("fill: *** Getting session '%s'", session);
+
         keyfile = find_valid_session_keyfile (session);
+
+        if (!keyfile)
+                return NULL;
+
+        session_runnable = TRUE;
+
+        value = g_key_file_get_string (keyfile,
+                                       GSM_KEYFILE_SESSION_GROUP, GSM_KEYFILE_RUNNABLE_KEY,
+                                       NULL);
+        if (!IS_STRING_EMPTY (value)) {
+                g_debug ("fill: *** Launching helper '%s' to know if session is runnable", value);
+                session_runnable = gsm_process_helper (value, GSM_RUNNABLE_HELPER_TIMEOUT, &error);
+                if (!session_runnable) {
+                        g_warning ("Session '%s' runnable check failed: %s", session,
+                                   error->message);
+                        g_clear_error (&error);
+                }
+        }
+        g_free (value);
+
+        if (session_runnable) {
+                session_runnable = check_required (keyfile);
+        }
+
+        if (session_runnable) {
+                *actual_session = g_strdup (session);
+                if (is_fallback)
+                        *is_fallback = FALSE;
+                return keyfile;
+        }
+
+        g_debug ("fill: *** Session is not runnable");
+
+        /* We can't run this session, so try to use the fallback */
+        value = g_key_file_get_string (keyfile,
+                                       GSM_KEYFILE_SESSION_GROUP, GSM_KEYFILE_FALLBACK_KEY,
+                                       NULL);
+
+        g_key_file_free (keyfile);
+        keyfile = NULL;
+
+        if (!IS_STRING_EMPTY (value)) {
+                if (is_fallback)
+                        *is_fallback = TRUE;
+                keyfile = get_session_keyfile (value, actual_session, NULL);
+        }
+        g_free (value);
+
         return keyfile;
 }
 
@@ -144,13 +293,17 @@ gsm_session_fill (GsmManager  *manager,
                   const char  *session)
 {
         GKeyFile *keyfile;
+        gboolean is_fallback;
+        char *actual_session;
 
-        keyfile = get_session_keyfile (session);
+        keyfile = get_session_keyfile (session, &actual_session, &is_fallback);
 
         if (!keyfile)
                 return FALSE;
 
-        _gsm_manager_set_active_session (manager, session);
+        _gsm_manager_set_active_session (manager, actual_session, is_fallback);
+
+        g_free (actual_session);
 
         load_standard_apps (manager, keyfile);
 
diff --git a/gnome-session/gsm-shell-extensions.c b/gnome-session/gsm-shell-extensions.c
new file mode 100644
index 00000000..064babe4
--- /dev/null
+++ b/gnome-session/gsm-shell-extensions.c
@@ -0,0 +1,197 @@
+/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
+/*
+ * Copyright (C) 2011 Red Hat, Inc
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2, or (at your option)
+ * any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authors:
+ *      Jasper St. Pierre <jstpierre@mecheye.net>
+ */
+
+#include <config.h>
+
+#include <glib.h>
+#include <gio/gio.h>
+#include <json-glib/json-glib.h>
+
+#include "gsm-shell-extensions.h"
+
+#define SHELL_SCHEMA "org.gnome.shell"
+#define DISABLE_EXTENSIONS_KEY "disable-user-extensions"
+
+struct _GsmShellExtensionsPrivate
+{
+  GSettings *settings;
+  guint num_extensions;
+};
+
+G_DEFINE_TYPE_WITH_CODE (GsmShellExtensions, gsm_shell_extensions, G_TYPE_OBJECT,
+                         G_ADD_PRIVATE (GsmShellExtensions));
+
+/**
+ * gsm_shell_extensions_finalize:
+ * @object: (in): A #GsmShellExtensions.
+ *
+ * Finalizer for a #GsmShellExtensions instance.  Frees any resources held by
+ * the instance.
+ */
+static void
+gsm_shell_extensions_finalize (GObject *object)
+{
+  GsmShellExtensions *extensions = GSM_SHELL_EXTENSIONS (object);
+  GsmShellExtensionsPrivate *priv = extensions->priv;
+
+  g_clear_object (&priv->settings);
+
+  G_OBJECT_CLASS (gsm_shell_extensions_parent_class)->finalize (object);
+}
+
+/**
+ * gsm_shell_extensions_class_init:
+ * @klass: (in): A #GsmShellExtensionsClass.
+ *
+ * Initializes the #GsmShellExtensionsClass and prepares the vtable.
+ */
+static void
+gsm_shell_extensions_class_init (GsmShellExtensionsClass *klass)
+{
+  GObjectClass *object_class;
+
+  object_class = G_OBJECT_CLASS (klass);
+  object_class->finalize = gsm_shell_extensions_finalize;
+}
+
+static void
+gsm_shell_extensions_scan_dir (GsmShellExtensions *self,
+                               GFile              *dir)
+{
+  GFileEnumerator *enumerator;
+  GFileInfo *info;
+  JsonParser *metadata_parser;
+
+  metadata_parser = json_parser_new ();
+
+  enumerator = g_file_enumerate_children (dir,
+                                          "standard::*",
+                                          G_FILE_QUERY_INFO_NONE,
+                                          NULL,
+                                          NULL);
+
+  if (enumerator == NULL)
+    return;
+
+  while ((info = g_file_enumerator_next_file (enumerator, NULL, NULL)) != NULL)
+    {
+      gchar *metadata_filename;
+      const gchar *metadata_uuid;
+      gchar *dir_uuid;
+      JsonObject *metadata_root;
+
+      dir_uuid = (char *) g_file_info_get_name (info);
+
+      metadata_filename = g_build_filename (g_file_get_path (dir),
+                                            dir_uuid,
+                                            "metadata.json",
+                                            NULL);
+
+      if (!json_parser_load_from_file (metadata_parser, metadata_filename, NULL))
+        continue;
+
+      g_free (metadata_filename);
+
+      metadata_root = json_node_get_object (json_parser_get_root (metadata_parser));
+
+      metadata_uuid = json_object_get_string_member (metadata_root, "uuid");
+      if (!g_str_equal (metadata_uuid, dir_uuid))
+        {
+          g_warning ("Extension with dirname '%s' does not match metadata's UUID of '%s'. Skipping.",
+                     dir_uuid, metadata_uuid);
+          continue;
+        }
+
+      self->priv->num_extensions++;
+    }
+}
+
+static void
+gsm_shell_extensions_scan (GsmShellExtensions *self)
+{
+  gchar *dirname;
+  GFile *dir;
+  const gchar * const * system_data_dirs;
+  int                   i;
+
+  /* User data dir first. */
+  dirname = g_build_filename (g_get_user_data_dir (), "gnome-shell", "extensions", NULL);
+  dir = g_file_new_for_path (dirname);
+  g_free (dirname);
+
+  gsm_shell_extensions_scan_dir (self, dir);
+  g_object_unref (dir);
+
+  system_data_dirs = g_get_system_data_dirs ();
+  for (i = 0; system_data_dirs[i]; i++)
+    {
+      dirname = g_build_filename (system_data_dirs[i], "gnome-shell", "extensions", NULL);
+      dir = g_file_new_for_path (dirname);
+      g_free (dirname);
+
+      gsm_shell_extensions_scan_dir (self, dir);
+      g_object_unref (dir);
+    }
+}
+
+/**
+ * gsm_shell_extensions_init:
+ * @self: (in): A #GsmShellExtensions.
+ *
+ * Initializes the newly created #GsmShellExtensions instance.
+ */
+static void
+gsm_shell_extensions_init (GsmShellExtensions *self)
+{
+  GSettingsSchemaSource *source;
+  GSettingsSchema *schema;
+
+  self->priv = gsm_shell_extensions_get_instance_private (self);
+
+  source = g_settings_schema_source_get_default ();
+  schema = g_settings_schema_source_lookup (source, SHELL_SCHEMA, TRUE);
+
+  if (schema != NULL)
+    {
+      self->priv->settings = g_settings_new_full (schema, NULL, NULL);
+      g_settings_schema_unref (schema);
+    }
+
+  if (self->priv->settings != NULL)
+    gsm_shell_extensions_scan (self);
+}
+
+gboolean
+gsm_shell_extensions_disable_all (GsmShellExtensions *self)
+{
+  return g_settings_set_boolean (self->priv->settings,
+                                 DISABLE_EXTENSIONS_KEY,
+                                 TRUE);
+}
+
+guint
+gsm_shell_extensions_n_extensions (GsmShellExtensions *self)
+{
+  if (self->priv->settings == NULL)
+    return 0;
+
+  return self->priv->num_extensions;
+}
diff --git a/gnome-session/gsm-shell-extensions.h b/gnome-session/gsm-shell-extensions.h
new file mode 100644
index 00000000..a3b3d063
--- /dev/null
+++ b/gnome-session/gsm-shell-extensions.h
@@ -0,0 +1,61 @@
+/* -*- mode: C; c-file-style: "gnu"; indent-tabs-mode: nil; -*- */
+/*
+ * Copyright (C) 2011 Red Hat, Inc
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2, or (at your option)
+ * any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ *
+ * Authors:
+ *      Jasper St. Pierre <jstpierre@mecheye.net>
+ */
+
+#ifndef __GSM_SHELL_EXTENSIONS_H
+#define __GSM_SHELL_EXTENSIONS_H
+
+#include <glib-object.h>
+
+G_BEGIN_DECLS
+
+#define GSM_TYPE_SHELL_EXTENSIONS            (gsm_shell_extensions_get_type ())
+#define GSM_SHELL_EXTENSIONS(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), GSM_TYPE_SHELL_EXTENSIONS, GsmShellExtensions))
+#define GSM_SHELL_EXTENSIONS_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass),  GSM_TYPE_SHELL_EXTENSIONS, GsmShellExtensionsClass))
+#define GSM_IS_SHELL_EXTENSIONS(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GSM_TYPE_SHELL_EXTENSIONS))
+#define GSM_IS_SHELL_EXTENSIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass),  GSM_TYPE_SHELL_EXTENSIONS))
+#define GSM_SHELL_EXTENSIONS_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj),  GSM_TYPE_SHELL_EXTENSIONS, GsmShellExtensionsClass))
+
+typedef struct _GsmShellExtensions        GsmShellExtensions;
+typedef struct _GsmShellExtensionsClass   GsmShellExtensionsClass;
+typedef struct _GsmShellExtensionsPrivate GsmShellExtensionsPrivate;
+
+struct _GsmShellExtensions
+{
+    GObject parent;
+
+    /*< private >*/
+    GsmShellExtensionsPrivate *priv;
+};
+
+struct _GsmShellExtensionsClass
+{
+    GObjectClass parent_class;
+};
+
+GType gsm_shell_extensions_get_type                   (void) G_GNUC_CONST;
+
+gboolean gsm_shell_extensions_disable_all             (GsmShellExtensions *self);
+
+guint gsm_shell_extensions_n_extensions               (GsmShellExtensions *self);
+
+G_END_DECLS
+
+#endif /* __GSM_SHELL_EXTENSIONS_H */
diff --git a/gnome-session/gsm-system.c b/gnome-session/gsm-system.c
index dc49a1af..be224244 100644
--- a/gnome-session/gsm-system.c
+++ b/gnome-session/gsm-system.c
@@ -73,6 +73,7 @@ typedef GObject GsmSystemNull;
 typedef GObjectClass GsmSystemNullClass;
 
 static void do_nothing (void) { }
+static gboolean return_true (void) { return TRUE; }
 static gboolean return_false (void) { return FALSE; }
 
 static void
@@ -90,9 +91,11 @@ gsm_system_null_init_iface (GsmSystemInterface *iface)
         iface->suspend           = (void *) do_nothing;
         iface->hibernate         = (void *) do_nothing;
         iface->set_session_idle  = (void *) do_nothing;
+        iface->is_login_session  = (void *) return_true;
         iface->set_inhibitors    = (void *) do_nothing;
         iface->prepare_shutdown  = (void *) do_nothing;
         iface->complete_shutdown = (void *) do_nothing;
+        iface->is_last_session_for_user = (void *) return_false;
 }
 
 static void
@@ -213,6 +216,18 @@ gsm_system_set_inhibitors (GsmSystem        *system,
         GSM_SYSTEM_GET_IFACE (system)->set_inhibitors (system, flags);
 }
 
+gboolean
+gsm_system_is_login_session (GsmSystem *system)
+{
+        return GSM_SYSTEM_GET_IFACE (system)->is_login_session (system);
+}
+
+gboolean
+gsm_system_is_last_session_for_user (GsmSystem *system)
+{
+        return GSM_SYSTEM_GET_IFACE (system)->is_last_session_for_user (system);
+}
+
 /**
  * gsm_system_is_active:
  *
diff --git a/gnome-session/gsm-system.h b/gnome-session/gsm-system.h
index 2f137422..438434cc 100644
--- a/gnome-session/gsm-system.h
+++ b/gnome-session/gsm-system.h
@@ -64,11 +64,13 @@ struct _GsmSystemInterface
         void     (* hibernate)        (GsmSystem *system);
         void     (* set_session_idle) (GsmSystem *system,
                                        gboolean   is_idle);
+        gboolean (* is_login_session) (GsmSystem *system);
         void     (* set_inhibitors)   (GsmSystem        *system,
                                        GsmInhibitorFlag  flags);
         void     (* prepare_shutdown) (GsmSystem   *system,
                                        gboolean     restart);
         void     (* complete_shutdown)(GsmSystem   *system);
+        gboolean (* is_last_session_for_user) (GsmSystem *system);
 };
 
 enum _GsmSystemError {
@@ -108,6 +110,10 @@ void       gsm_system_hibernate        (GsmSystem *system);
 void       gsm_system_set_session_idle (GsmSystem *system,
                                         gboolean   is_idle);
 
+gboolean   gsm_system_is_login_session (GsmSystem *system);
+
+gboolean   gsm_system_is_last_session_for_user (GsmSystem *system);
+
 gboolean   gsm_system_is_active        (GsmSystem *system);
 
 void       gsm_system_set_inhibitors   (GsmSystem        *system,
diff --git a/gnome-session/gsm-systemd.c b/gnome-session/gsm-systemd.c
index 6f5a03d8..9271e7fe 100644
--- a/gnome-session/gsm-systemd.c
+++ b/gnome-session/gsm-systemd.c
@@ -707,6 +707,31 @@ gsm_systemd_can_stop (GsmSystem *system)
         return can_stop;
 }
 
+static gboolean
+gsm_systemd_is_login_session (GsmSystem *system)
+{
+        GsmSystemd *manager = GSM_SYSTEMD (system);
+        int res;
+        gboolean ret;
+        gchar *session_class = NULL;
+
+        ret = FALSE;
+
+        if (manager->priv->session_id == NULL) {
+                return ret;
+        }
+
+        res = sd_session_get_class (manager->priv->session_id, &session_class);
+        if (res < 0) {
+                g_warning ("Could not get session class: %s", strerror (-res));
+                return FALSE;
+        }
+        ret = (g_strcmp0 (session_class, "greeter") == 0);
+        free (session_class);
+
+        return ret;
+}
+
 static gboolean
 gsm_systemd_can_suspend (GsmSystem *system)
 {
@@ -1032,6 +1057,66 @@ gsm_systemd_complete_shutdown (GsmSystem *system)
         drop_delay_inhibitor (systemd);
 }
 
+static gboolean
+gsm_systemd_is_last_session_for_user (GsmSystem *system)
+{
+        char **sessions = NULL;
+        char *session = NULL;
+        gboolean is_last_session;
+        int ret, i;
+
+        if (!gsm_systemd_find_session (&session)) {
+                return FALSE;
+        }
+
+        ret = sd_uid_get_sessions (getuid (), FALSE, &sessions);
+
+        if (ret <= 0) {
+                free (session);
+                return FALSE;
+        }
+
+        is_last_session = TRUE;
+        for (i = 0; sessions[i]; i++) {
+                char *state = NULL;
+                char *type = NULL;
+
+                if (g_strcmp0 (sessions[i], session) == 0)
+                        continue;
+
+                ret = sd_session_get_state (sessions[i], &state);
+
+                if (ret != 0)
+                        continue;
+
+                if (g_strcmp0 (state, "closing") == 0) {
+                        free (state);
+                        continue;
+                }
+                free (state);
+
+                ret = sd_session_get_type (sessions[i], &type);
+
+                if (ret != 0)
+                        continue;
+
+                if (g_strcmp0 (type, "x11") != 0 &&
+                    g_strcmp0 (type, "wayland") != 0) {
+                        free (type);
+                        continue;
+                }
+
+                is_last_session = FALSE;
+        }
+
+        for (i = 0; sessions[i]; i++)
+                free (sessions[i]);
+        free (sessions);
+        free (session);
+
+        return is_last_session;
+}
+
 static void
 gsm_systemd_system_init (GsmSystemInterface *iface)
 {
@@ -1047,9 +1132,11 @@ gsm_systemd_system_init (GsmSystemInterface *iface)
         iface->suspend = gsm_systemd_suspend;
         iface->hibernate = gsm_systemd_hibernate;
         iface->set_session_idle = gsm_systemd_set_session_idle;
+        iface->is_login_session = gsm_systemd_is_login_session;
         iface->set_inhibitors = gsm_systemd_set_inhibitors;
         iface->prepare_shutdown = gsm_systemd_prepare_shutdown;
         iface->complete_shutdown = gsm_systemd_complete_shutdown;
+        iface->is_last_session_for_user = gsm_systemd_is_last_session_for_user;
 }
 
 GsmSystemd *
